* DISK.PRG
* Andrew Schulman, 8/16/87
* 12 Humboldt Street, Cambridge MA 02140
* Illustrates calling ROM BIOS and DOS interrupts from dBase III Plus
* also works with FoxBase+
* to accompany October 1987 Data Based Advisor "Inside dBase"

parameter dsk

* load inter

if .not. file("inter.bin")
    ? "This program requires INTER.BIN"
    return
endif

disk=upper(dsk)

* if it's a floppy, see if there's really a disk there!
* call the ROM BIOS instead of DOS, so we DON'T get "Abort,Retry,Ignore"
if (disk = "A" .or. disk = "B")
    attempt=0
    do while (attempt < 3)      && sometimes you have to try a few times!
        ax=(4*256)+1            && Verify Sector: INT13, function call 4
        bx=0                        
        cx=(0*256)+1                                && track 0, sector 1
        dx=(0*256)+(asc(upper(dsk))-asc("A"))       && drive ?, head 0
        cmd = "19"+str(ax)+str(bx)+str(cx)+str(dx)+space(10)
        call inter with cmd
        ax=int(val(substr(cmd,1,5)))
        ah=int(ax/256)
        if (ah = 0)
            exit                    && we're okay, break out of loop
        else                        && if AH<>0, there's probably no disk!
            ?? "......"
            ax=(0*256)              && Reset Floppy Disk: function call 0
            cmd = "19"+str(ax)+str(0)+str(0)+str(0)+space(10)
            call inter with cmd
        endif
        attempt = attempt + 1
    enddo
    if (attempt = 3)
        ? "Sorry, couldn't find disk!"
        return
    endif
endif

* find out what's there
ax=54*256           && GetFreeSpace: INT21, function call 36h
dx=1+asc(disk)-asc("A")     && A=1, B=2, C=3, etc.
cmd = "33"+str(ax)+str(0)+str(0)+str(dx)+space(10)
call inter with cmd
* parse return string into registers
ax=int(val(substr(cmd,1,5)))
bx=int(val(substr(cmd,7,5)))
cx=int(val(substr(cmd,13,5)))
dx=int(val(substr(cmd,19,5)))
if (ax = 65535)     && FFFFh means invalid drive
    ? "Invalid drive"
else
    ? ax*bx*cx, "Total bytes free"
    ? ax*dx*cx, "Total bytes on drive"
endif


